#include "gpio.hpp"

using namespace stm32f072xb;

Gpio<Port::A>::Gpio(AbstractGpioInit gpioInit) : AbstractGpio(GPIOA, gpioInit) {
	SET_BIT(RCC->AHBENR, RCC_AHBENR_GPIOAEN);  // enable GPIOA (p.120)
	this->setupRegister();
}

Gpio<Port::B>::Gpio(AbstractGpioInit gpioInit) : AbstractGpio(GPIOB, gpioInit) {
	SET_BIT(RCC->AHBENR, RCC_AHBENR_GPIOBEN);
	this->setupRegister();
}
Gpio<Port::C>::Gpio(AbstractGpioInit gpioInit) : AbstractGpio(GPIOC, gpioInit) {
	SET_BIT(RCC->AHBENR, RCC_AHBENR_GPIOCEN);
	this->setupRegister();
}

Gpio<Port::D>::Gpio(AbstractGpioInit gpioInit) : AbstractGpio(GPIOD, gpioInit) {
	SET_BIT(RCC->AHBENR, RCC_AHBENR_GPIODEN);
	this->setupRegister();
}
Gpio<Port::E>::Gpio(AbstractGpioInit gpioInit) : AbstractGpio(GPIOE, gpioInit) {
	SET_BIT(RCC->AHBENR, RCC_AHBENR_GPIOEEN);
	this->setupRegister();
}

Gpio<Port::F>::Gpio(AbstractGpioInit gpioInit) : AbstractGpio(GPIOF, gpioInit) {
	SET_BIT(RCC->AHBENR, RCC_AHBENR_GPIOFEN);
	this->setupRegister();
}
